'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = awaitMiddleware;

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function awaitMiddleware() {
  return function (next) {
    return function (action) {
      var promise = action.promise;
      var type = action.type;

      var rest = _objectWithoutProperties(action, ['promise', 'type']);

      if (!promise) return next(action);

      var SUCCESS = type;
      var REQUEST = type + '_REQUEST';
      var FAILURE = type + '_FAILURE';

      next(_extends({}, rest, { type: REQUEST }));

      return promise.then(function (res) {
        next(_extends({}, rest, { res: res, type: SUCCESS }));
        return true;
      }).catch(function (error) {
        next(_extends({}, rest, { error: error, type: FAILURE }));
        console.log(error);
        return false;
      });
    };
  };
}
module.exports = exports['default'];